<!DOCTYPE html>
<html lang="en">
    <meta charset="utf-8" />
    <title>Handwritten Digits</title>
    <head>
        <link rel="stylesheet" href="https://code.getmdl.io/1.3.0/material.blue_grey-blue.min.css"/> 
        <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
        <link rel="stylesheet" href="style.css">
        <script src="https://code.getmdl.io/1.3.0/material.min.js"></script>
        <link rel="shortcut icon" type="image/png" href="/favicon.png"/>
        <link rel="stylesheet"
        href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/styles/atom-one-dark-reasonable.min.css">
      <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>
      <script>hljs.initHighlightingOnLoad();</script>
    </head>
    <body>
        <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
            <header class="mdl-layout__header">
              <div class="mdl-layout__header-row">
                <span class="mdl-layout-title">IB Personal Project</span>
              </div>
              <div class="mdl-layout__tab-bar mdl-js-ripple-effect mdl-layout--large-screen-only">
                <a href="index.html" class="mdl-layout__tab">Home</a>
                <a href="prices.html" class="mdl-layout__tab">Housing Prices</a>
                <a href="digits.html" class="mdl-layout__tab is-active">Handwritten Digits</a>
                <a href="reviews.html" class="mdl-layout__tab">Movie Reviews</a>
                <a href="entries.html" class="mdl-layout__tab">Journal Entries</a>
              </div>
            </header>
            <div class="mdl-layout__drawer mdl-layout--small-screen-only">
              <span class="mdl-layout__title">IB Personal Project</span>
              <nav class="mdl-navigation">
                <a class="mdl-navigation__link" href="index.html">Home</a>
                <a class="mdl-navigation__link" href="prices.html">Housing Prices</a>
                <a class="mdl-navigation__link" href="digits.html">Handwritten Digits</a>
                <a class="mdl-navigation__link" href="reviews.html">Movie Reviews</a>
                <a class="mdl-navigation__link" href="entries.html">Journal Entries</a>
              </nav>
            </div>
            <main class="mdl-layout__content">
                <div class="mdl-grid">
                    <div class="mdl-cell mdl-cell--4-col"></div>
                    <div class="mdl-cell mdl-cell--4-col centre">
                        <h1>What is this?</h1><br>
                        <p>This is one of the two more polished applications I did. This application uses many of the neural network concepts that I learned to effectively create a classifier style neural network that can identify handwritten digits from the MNIST database.</p>
                    </div>
                    <div class="mdl-cell mdl-cell--4-col"></div>
                </div>
                <div class="page-content">
                  <pre><code class="python">
                    """
                    Build a multi-class classification with 10 classes
                    """
                    from __future__ import print_function

                    import glob
                    import math
                    import os

                    from IPython import display
                    from matplotlib import cm
                    from matplotlib import gridspec
                    from matplotlib import pyplot as plt
                    import numpy as np
                    import pandas as pd
                    import seaborn as sns
                    from sklearn import metrics
                    import tensorflow as tf
                    from tensorflow.python.data import Dataset

                    tf.compat.v1.logging.set_verbosity(tf.compat.v1.logging.ERROR)
                    pd.options.display.max_rows = 10
                    pd.options.display.float_format = '{:.1f}'.format

                    # A massive dataset of handwritten digits that I don't want to download
                    mnist_dataframe = pd.read_csv(
                      "https://download.mlcc.google.com/mledu-datasets/mnist_train_small.csv",
                      sep=",",
                      header=None)

                    # Use just the first 10,000 records for training/validation.
                    mnist_dataframe = mnist_dataframe.head(10000)

                    # randomise the dataset as normal
                    mnist_dataframe = mnist_dataframe.reindex(np.random.permutation(mnist_dataframe.index))
                    mnist_dataframe.head()

                    def parse_labels_and_features(dataset):
                      """Extracts labels and features.
  
                      This is a good place to scale or transform the features I need to
  
                      Args:
                        dataset: A `DataFrame`, containing the label on the first column and
                          monochrome pixel values on the remaining columns, in row major order.
                      Returns:
                        A `tuple` `(labels, features)`:
                          labels: A Pandas `Series`.
                          features: A Pandas `DataFrame`.
                      """
                      labels = dataset[0]

                      # DataFrame.loc index ranges are inclusive at both ends.
                      features = dataset.loc[:,1:784]
                      # Scale the data to [0, 1] by dividing out the max value, 255.
                      features = features / 255

                      return labels, features
                    # Normal descriptive statistics
                    training_targets, training_examples = parse_labels_and_features(mnist_dataframe[:7500])
                    training_examples.describe()

                    validation_targets, validation_examples = parse_labels_and_features(mnist_dataframe[7500:10000])
                    validation_examples.describe()

                    # Output a random example and the label for testing

                    rand_example = np.random.choice(training_examples.index)
                    _, ax = plt.subplots()
                    ax.matshow(training_examples.loc[rand_example].values.reshape(28, 28))
                    ax.set_title("Label: %i" % training_targets.loc[rand_example])
                    ax.grid(False)

                    def construct_feature_columns():
                      """Construct the TensorFlow Feature Columns.

                      Returns:
                        A set of feature columns
                      """ 
  
                      # There are 784 pixels in each image.
                      return set([tf.feature_column.numeric_column('pixels', shape=784)])

                    def create_training_input_fn(features, labels, batch_size, num_epochs=None, shuffle=True):
                      """A custom input_fn for sending MNIST data to the estimator for training.

                      Args:
                        features: The training features.
                        labels: The training labels.
                        batch_size: Batch size to use during training.

                      Returns:
                        A function that returns batches of training features and labels during
                        training.
                      """
                      def _input_fn(num_epochs=None, shuffle=True):
                        # Input pipelines are reset with each call to .train(). To ensure model
                        # gets a good sampling of data, even when number of steps is small, we 
                        # shuffle all the data before creating the Dataset object
                        idx = np.random.permutation(features.index)
                        raw_features = {"pixels":features.reindex(idx)}
                        raw_targets = np.array(labels[idx])
   
                        ds = Dataset.from_tensor_slices((raw_features,raw_targets)) # warning: 2GB limit
                        ds = ds.batch(batch_size).repeat(num_epochs)
    
                        if shuffle:
                          ds = ds.shuffle(10000)
    
                        # Return the next batch of data.
                        feature_batch, label_batch = ds.make_one_shot_iterator().get_next()
                        return feature_batch, label_batch

                      return _input_fn

                    def create_predict_input_fn(features, labels, batch_size):
                      """A custom input_fn for sending mnist data to the estimator for predictions.

                      Args:
                        features: The features to base predictions on.
                        labels: The labels of the prediction examples.

                      Returns:
                        A function that returns features and labels for predictions.
                      """
                      def _input_fn():
                        raw_features = {"pixels": features.values}
                        raw_targets = np.array(labels)
    
                        ds = Dataset.from_tensor_slices((raw_features, raw_targets)) # warning: 2GB limit
                        ds = ds.batch(batch_size)
    
        
                        # Return the next batch of data.
                        feature_batch, label_batch = ds.make_one_shot_iterator().get_next()
                        return feature_batch, label_batch

                      return _input_fn

                    def train_nn_classification_model(
                        learning_rate,
                        steps,
                        batch_size,
                        hidden_units,
                        training_examples,
                        training_targets,
                        validation_examples,
                        validation_targets):
                      """Trains a neural network classification model for the MNIST digits dataset.
  
                      In addition to training, this function also prints training progress information,
                      a plot of the training and validation loss over time, as well as a confusion
                      matrix.
  
                      Args:
                        learning_rate: A `float`, the learning rate to use.
                        steps: A non-zero `int`, the total number of training steps. A training step
                          consists of a forward and backward pass using a single batch.
                        batch_size: A non-zero `int`, the batch size.
                        hidden_units: A `list` of int values, specifying the number of neurons in each layer.
                        training_examples: A `DataFrame` containing the training features.
                        training_targets: A `DataFrame` containing the training labels.
                        validation_examples: A `DataFrame` containing the validation features.
                        validation_targets: A `DataFrame` containing the validation labels.
      
                      Returns:
                        The trained `DNNClassifier` object.
                      """

                      periods = 10
                      # Caution: input pipelines are reset with each call to train. 
                      # If the number of steps is small, your model may never see most of the data.  
                      # So with multiple `.train` calls like this you may want to control the length 
                      # of training with num_epochs passed to the input_fn. Or, you can do a really-big shuffle, 
                      # or since it's in-memory data, shuffle all the data in the `input_fn`.
                      steps_per_period = steps / periods  
  
                      # Create the input functions.
                      predict_training_input_fn = create_predict_input_fn(
                        training_examples, training_targets, batch_size)
                      predict_validation_input_fn = create_predict_input_fn(
                        validation_examples, validation_targets, batch_size)
                      training_input_fn = create_training_input_fn(
                        training_examples, training_targets, batch_size)
  
                      # Create feature columns.
                      feature_columns = [tf.feature_column.numeric_column('pixels', shape=784)]

                      # Create a DNNClassifier object.
                      my_optimizer = tf.train.AdagradOptimizer(learning_rate=learning_rate)
                      my_optimizer = tf.contrib.estimator.clip_gradients_by_norm(my_optimizer, 5.0)
                      classifier = tf.estimator.DNNClassifier(
                          feature_columns=feature_columns,
                          n_classes=10,
                          hidden_units=hidden_units,
                          optimizer=my_optimizer,
                          config=tf.contrib.learn.RunConfig(keep_checkpoint_max=1)
                      )

                      # Train the model, but do so inside a loop so that we can periodically assess
                      # loss metrics.
                      print("Training model...")
                      print("LogLoss error (on validation data):")
                      training_errors = []
                      validation_errors = []
                      for period in range (0, periods):
                        # Train the model, starting from the prior state.
                        classifier.train(
                            input_fn=training_input_fn,
                            steps=steps_per_period
                        )
  
                        # Take a break and compute probabilities.
                        training_predictions = list(classifier.predict(input_fn=predict_training_input_fn))
                        training_probabilities = np.array([item['probabilities'] for item in training_predictions])
                        training_pred_class_id = np.array([item['class_ids'][0] for item in training_predictions])
                        training_pred_one_hot = tf.keras.utils.to_categorical(training_pred_class_id,10)
        
                        validation_predictions = list(classifier.predict(input_fn=predict_validation_input_fn))
                        validation_probabilities = np.array([item['probabilities'] for item in validation_predictions])    
                        validation_pred_class_id = np.array([item['class_ids'][0] for item in validation_predictions])
                        validation_pred_one_hot = tf.keras.utils.to_categorical(validation_pred_class_id,10)    
    
                        # Compute training and validation errors.
                        training_log_loss = metrics.log_loss(training_targets, training_pred_one_hot)
                        validation_log_loss = metrics.log_loss(validation_targets, validation_pred_one_hot)
                        # Occasionally print the current loss.
                        print("  period %02d : %0.2f" % (period, validation_log_loss))
                        # Add the loss metrics from this period to our list.
                        training_errors.append(training_log_loss)
                        validation_errors.append(validation_log_loss)
                      print("Model training finished.")
                      # Remove event files to save disk space.
                      _ = map(os.remove, glob.glob(os.path.join(classifier.model_dir, 'events.out.tfevents*')))
  
                      # Calculate final predictions (not probabilities, as above).
                      final_predictions = classifier.predict(input_fn=predict_validation_input_fn)
                      final_predictions = np.array([item['class_ids'][0] for item in final_predictions])
  
  
                      accuracy = metrics.accuracy_score(validation_targets, final_predictions)
                      print("Final accuracy (on validation data): %0.2f" % accuracy)

                      # Output a graph of loss metrics over periods.
                      plt.ylabel("LogLoss")
                      plt.xlabel("Periods")
                      plt.title("LogLoss vs. Periods")
                      plt.plot(training_errors, label="training")
                      plt.plot(validation_errors, label="validation")
                      plt.legend()
                      plt.show()
  
                      # Output a plot of the confusion matrix.
                      cm = metrics.confusion_matrix(validation_targets, final_predictions)
                      # Normalize the confusion matrix by row (i.e by the number of samples
                      # in each class).
                      cm_normalized = cm.astype("float") / cm.sum(axis=1)[:, np.newaxis]
                      ax = sns.heatmap(cm_normalized, cmap="bone_r")
                      ax.set_aspect(1)
                      plt.title("Confusion matrix")
                      plt.ylabel("True label")
                      plt.xlabel("Predicted label")
                      plt.show()

                      return classifier
                    # This gives about .9 accuracy
                    classifier = train_nn_classification_model(
                        learning_rate=0.05,
                        steps=1000,
                        batch_size=30,
                        hidden_units=[100, 100],
                        training_examples=training_examples,
                        training_targets=training_targets,
                        validation_examples=validation_examples,
                        validation_targets=validation_targets)

                    # use test data as well
                    mnist_test_dataframe = pd.read_csv(
                      "https://download.mlcc.google.com/mledu-datasets/mnist_test.csv",
                      sep=",",
                      header=None)

                    test_targets, test_examples = parse_labels_and_features(mnist_test_dataframe)
                    test_examples.describe()

                    predict_test_input_fn = create_predict_input_fn(
                        test_examples, test_targets, batch_size=100)

                    test_predictions = classifier.predict(input_fn=predict_test_input_fn)
                    test_predictions = np.array([item['class_ids'][0] for item in test_predictions])
  
                    accuracy = metrics.accuracy_score(test_targets, test_predictions)
                    print("Accuracy on test data: %0.2f" % accuracy)

                    # visualise the weights of the first neural network

                    print(classifier.get_variable_names())

                    weights0 = classifier.get_variable_value("dnn/hiddenlayer_0/kernel")

                    print("weights0 shape:", weights0.shape)

                    num_nodes = weights0.shape[1]
                    num_rows = int(math.ceil(num_nodes / 10.0))
                    fig, axes = plt.subplots(num_rows, 10, figsize=(20, 2 * num_rows))
                    for coef, ax in zip(weights0.T, axes.ravel()):
                        # Weights in coef is reshaped from 1x784 to 28x28.
                        ax.matshow(coef.reshape(28, 28), cmap=plt.cm.pink)
                        ax.set_xticks(())
                        ax.set_yticks(())

                    plt.show()
                  </code></pre>
                  <div class="centre">
                    <h1>Results:</h1>
                    <img src=assets/digits-code1.png>
                    <img src=assets/digits-code2.png>
                    <img src=assets/digits-graph1.png>
                    <img src=assets/digits-graph2.png>
                    <img src=assets/digits-graph3.png>
                  </div>
                </div>
            </main>
          </div>
    </body>
</html>